
#include <idc.idc>

static FillNOP(addr, len)
{
   auto i;
   for(i = 0; i < len; i = i + 1)
      PatchByte(addr+i, 0x90);
}

static find_poly1(ea)
{
   auto i, len;
   len = 57;
   i = 1;
   for(;;) {
      ea=FindBinary(ea, SEARCH_DOWN, "EB 01 ? 9C EB 01 ? 51 EB 01 ? 81 FF ? ? ? ? EB 01 ? 83 E1 00 EB 01 ? F3 AE"); 
      if(ea==BADADDR) {
         Message(form("Obfuscation (type1) %d\n", i-1));
         return;
      }
      if(ea != 0) {
         FillNOP(ea, len);
         MakeUnknown(ea, len, 0);
         MakeData(ea+1, FF_BYTE, 1, 0);
         MakeArray(ea+1, len-1);
         HideArea(ea+1, ea+len, 
                  form("Obfuscation (type1) #%03d [%08X - %08X]",i,ea,ea+len), 
                  "==>", "<==", -1);
         ea = ea + len-1;
         i = i + 1;
      }
      else
         ea = ea + 1;
   }
}

static find_poly2(ea)
{
   auto i, len;
   len = 45;
   i = 1;
   for(;;) {
      ea=FindBinary(ea, SEARCH_DOWN, "EB 01  ? 8D 00 EB 01  ? 8D 09 EB 01  ? 8D 12 EB 01  ? 8D 1B EB 01  ? 8D 24 24 EB 01"); 
      if(ea==BADADDR) {
         Message(form("Obfuscation (type2) %d\n", i-1));
         return;
      }
      if(ea != 0) {
         FillNOP(ea, len);
         MakeUnknown(ea, len, 0);
         MakeData(ea+1, FF_BYTE, 1, 0);
         MakeArray(ea+1, len-1);
         HideArea(ea+1, ea+len, 
                  form("Obfuscation (type2) #%03d [%08X - %08X]",i,ea,ea+len), 
                  "==>", "<==", -1);
         ea = ea + len-1;
         i = i + 1;
      }
      else
         ea = ea + 1;
   }
}

static find_poly3(ea)
{
   auto i, len;
   len = 54;
   i = 1;
   for(;;) {
      ea=FindBinary(ea, SEARCH_DOWN, "EB 01  ? 9c EB 01  ? E8 01 00 00 00  ? EB 01  ? 81 04 24  ?  ?  ?  ? EB 01  ? 97 EB"); 
      if(ea==BADADDR) {
         Message(form("Obfuscation (type3) %d\n", i-1));
         return;
      }
      if(ea != 0) {
         FillNOP(ea, len);
         MakeUnknown(ea, len, 0);
         MakeData(ea+1, FF_BYTE, 1, 0);
         MakeArray(ea+1, len-1);
         HideArea(ea+1, ea+len, 
                  form("Obfuscation (type3) #%03d [%08X - %08X]",i,ea,ea+len), 
                  "==>", "<==", -1);
         ea = ea + len-1;
         i = i + 1;
      }
      else
         ea = ea + 1;
   }
}

static find_poly4(ea)
{
   auto i, len;
   len = 52;
   i = 1;
   for(;;) {
      ea=FindBinary(ea, SEARCH_DOWN, "EB 01  ? 55 EB 01  ? E8 04 00 00 00  ? EB 19  ? EB 01  ? 5D EB 01  ? 8D 6D 01 EB 01"); 
      if(ea==BADADDR) {
         Message(form("Obfuscation (type4) %d\n", i-1));
         return;
      }
      if(ea != 0) {
         FillNOP(ea, len);
         MakeUnknown(ea, len, 0);
         MakeData(ea+1, FF_BYTE, 1, 0);
         MakeArray(ea+1, len-1);
         HideArea(ea+1, ea+len, 
                  form("Obfuscation (type4) #%03d [%08X - %08X]",i,ea,ea+len), 
                  "==>", "<==", -1);
         ea = ea + len-1;
         i = i + 1;
      }
      else
         ea = ea + 1;
   }
}

static find_poly5(ea)
{
   auto i, len;
   len = 39;
   i = 1;
   for(;;) {
      ea=FindBinary(ea, SEARCH_DOWN, "EB 01  ? 74 06 EB 01  ? 75 0A E9 EB 01  ? E8 0A 00 00 00  ? EB 01  ? E8 01 00 00 00"); 
      if(ea==BADADDR) {
         Message(form("Obfuscation (type5) %d\n", i-1));
         return;
      }
      if(ea != 0) {
         FillNOP(ea, len);
         MakeUnknown(ea, len, 0);
         MakeData(ea+1, FF_BYTE, 1, 0);
         MakeArray(ea+1, len-1);
         HideArea(ea+1, ea+len, 
                  form("Obfuscation (type5) #%03d [%08X - %08X]",i,ea,ea+len), 
                  "==>", "<==", -1);
         ea = ea + len-1;
         i = i + 1;
      }
      else
         ea = ea + 1;
   }
}

static find_poly6(ea)
{
   auto i, len;
   len = 45;
   i = 1;
   for(;;) {
      ea=FindBinary(ea, SEARCH_DOWN, "EB 01  ? E8 10 00 00 00 EB 01 E8 17 00 00 00 EB 01 E8 09 00 00 00 EB 01 E8 F4 FF FF"); 
      if(ea==BADADDR) {
         Message(form("Obfuscation (type6) %d\n", i-1));
         return;
      }
      if(ea != 0) {
         FillNOP(ea, len);
         MakeUnknown(ea, len, 0);
         MakeData(ea+1, FF_BYTE, 1, 0);
         MakeArray(ea+1, len-1);
         HideArea(ea+1, ea+len, 
                  form("Obfuscation (type6) #%03d [%08X - %08X]",i,ea,ea+len), 
                  "==>", "<==", -1);
         ea = ea + len-1;
         i = i + 1;
      }
      else
         ea = ea + 1;
   }
}

static find_poly7(ea)
{
   auto i, len;
   len = 61;
   i = 1;
   for(;;) {
      ea=FindBinary(ea, SEARCH_DOWN, "EB 01  ? 8D 64 24 FC EB 01  ? 87 04 24 EB 01  ? 68  ?  ?  ?  ? EB 01  ? 58 EB 01  ?"); 
      if(ea==BADADDR) {
         Message(form("Obfuscation (type7) %d\n", i-1));
         return;
      }
      if(ea != 0) {
         FillNOP(ea, len);
         MakeUnknown(ea, len, 0);
         MakeData(ea+1, FF_BYTE, 1, 0);
         MakeArray(ea+1, len-1);
         HideArea(ea+1, ea+len, 
                  form("Obfuscation (type7) #%03d [%08X - %08X]",i,ea,ea+len), 
                  "==>", "<==", -1);
         ea = ea + len-1;
         i = i + 1;
      }
      else
         ea = ea + 1;
   }
}

static find_poly8(ea)
{
   auto i, len;
   len = 63;
   i = 1;
   for(;;) {
      ea=FindBinary(ea, SEARCH_DOWN, "EB 01  ? 87 F7 EB 01  ? 9C EB 01  ? 6A 00 EB 01  ? 01 14 24 EB 01  ? 81 F2  ?  ?  ?"); 
      if(ea==BADADDR) {
         Message(form("Obfuscation (type8) %d\n", i-1));
         return;
      }
      if(ea != 0) {
         FillNOP(ea, len);
         MakeUnknown(ea, len, 0);
         MakeData(ea+1, FF_BYTE, 1, 0);
         MakeArray(ea+1, len-1);
         HideArea(ea+1, ea+len, 
                  form("Obfuscation (type8) #%03d [%08X - %08X]",i,ea,ea+len), 
                  "==>", "<==", -1);
         ea = ea + len-1;
         i = i + 1;
      }
      else
         ea = ea + 1;
   }
}

static find_poly9(ea)
{
   auto i, len;
   len = 44;
   i = 1;
   for(;;) {
      ea=FindBinary(ea, SEARCH_DOWN, "EB 01  ? 68  ?  ?  ?  ? EB 01  ? 68  ?  ?  ?  ? EB 01  ? 87 04 24 EB 01  ? 87 5C 24"); 
      if(ea==BADADDR) {
         Message(form("Obfuscation (type9) %d\n", i-1));
         return;
      }
      if(ea != 0) {
         FillNOP(ea, len);
         MakeUnknown(ea, len, 0);
         MakeData(ea+1, FF_BYTE, 1, 0);
         MakeArray(ea+1, len-1);
         HideArea(ea+1, ea+len, 
                  form("Obfuscation (type9) #%03d [%08X - %08X]",i,ea,ea+len), 
                  "==>", "<==", -1);
         ea = ea + len-1;
         i = i + 1;
      }
      else
         ea = ea + 1;
   }
}

static find_poly10(ea)
{
   auto i, len;
   len = 51;
   i = 1;
   for(;;) {
      ea=FindBinary(ea, SEARCH_DOWN, "EB 01  ? E8 19 00 00 00 EB 01  ? E8 01 00 00 00 E9 EB 01  ? 87 04 24 EB 01  ? 58 EB"); 
      if(ea==BADADDR) {
         Message(form("Obfuscation (type10) %d\n", i-1));
         return;
      }
      if(ea != 0) {
         FillNOP(ea, len);
         MakeUnknown(ea, len, 0);
         MakeData(ea+1, FF_BYTE, 1, 0);
         MakeArray(ea+1, len-1);
         HideArea(ea+1, ea+len, 
                  form("Obfuscation (type10) #%03d [%08X - %08X]",i,ea,ea+len), 
                  "==>", "<==", -1);
         ea = ea + len-1;
         i = i + 1;
      }
      else
         ea = ea + 1;
   }
}

static find_poly11(ea)
{
   auto i, len;
   len = 71;
   i = 1;
   for(;;) {
      ea=FindBinary(ea, SEARCH_DOWN, "EB 01  ? 9C EB 01  ? 50 EB 01  ? 05  ?  ?  ?  ? EB 01  ? F7 D8 EB 01  ? 2D  ?  ?  ?"); 
      if(ea==BADADDR) {
         Message(form("Obfuscation (type11) %d\n", i-1));
         return;
      }
      if(ea != 0) {
         FillNOP(ea, len);
         MakeUnknown(ea, len, 0);
         MakeData(ea+1, FF_BYTE, 1, 0);
         MakeArray(ea+1, len-1);
         HideArea(ea+1, ea+len, 
                  form("Obfuscation (type11) #%03d [%08X - %08X]",i,ea,ea+len), 
                  "==>", "<==", -1);
         ea = ea + len-1;
         i = i + 1;
      }
      else
         ea = ea + 1;
   }
}

static find_poly12(ea)
{
   auto i, len;
   len = 42;
   i = 1;
   for(;;) {
      ea=FindBinary(ea, SEARCH_DOWN, "EB 01  ? 68  ?  ?  ?  ? EB 01  ? E8 12 00 00 00 EB 01  ? 8D 64 24 04 EB 01  ? 73 0B"); 
      if(ea==BADADDR) {
         Message(form("Obfuscation (type12) %d\n", i-1));
         return;
      }
      if(ea != 0) {
         FillNOP(ea, len);
         MakeUnknown(ea, len, 0);
         MakeData(ea+1, FF_BYTE, 1, 0);
         MakeArray(ea+1, len-1);
         HideArea(ea+1, ea+len, 
                  form("Obfuscation (type12) #%03d [%08X - %08X]",i,ea,ea+len), 
                  "==>", "<==", -1);
         ea = ea + len-1;
         i = i + 1;
      }
      else
         ea = ea + 1;
   }
}

static find_poly13(ea)
{
   auto i, len;
   len = 23;
   i = 1;
   for(;;) {
      ea=FindBinary(ea, SEARCH_DOWN, "EB 01  ? 7E 09 EB 01  ? 7D 04 EB 01  ? CC EB 01  ? 8D 6D 00 EB 01"); 
      if(ea==BADADDR) {
         Message(form("Obfuscation (type13) %d\n", i-1));
         return;
      }
      if(ea != 0) {
         FillNOP(ea, len);
         MakeUnknown(ea, len, 0);
         MakeData(ea+1, FF_BYTE, 1, 0);
         MakeArray(ea+1, len-1);
         HideArea(ea+1, ea+len, 
                  form("Obfuscation (type13) #%03d [%08X - %08X]",i,ea,ea+len), 
                  "==>", "<==", -1);
         ea = ea + len-1;
         i = i + 1;
      }
      else
         ea = ea + 1;
   }
}

static find_poly14(ea)
{
   auto i, len;
   len = 42;
   i = 1;
   for(;;) {
      ea=FindBinary(ea, SEARCH_DOWN, "EB 01  ? 90 EB 01  ? 87 C9 EB 01  ? 87 D2 EB 01  ? 87 DB EB 01  ? 87 E4 EB 01  ? 87"); 
      if(ea==BADADDR) {
         Message(form("Obfuscation (type14) %d\n", i-1));
         return;
      }
      if(ea != 0) {
         FillNOP(ea, len);
         MakeUnknown(ea, len, 0);
         MakeData(ea+1, FF_BYTE, 1, 0);
         MakeArray(ea+1, len-1);
         HideArea(ea+1, ea+len, 
                  form("Obfuscation (type14) #%03d [%08X - %08X]",i,ea,ea+len), 
                  "==>", "<==", -1);
         ea = ea + len-1;
         i = i + 1;
      }
      else
         ea = ea + 1;
   }
}

static find_poly15(ea)
{
   auto i, len;
   len = 51;
   i = 1;
   for(;;) {
      ea=FindBinary(ea, SEARCH_DOWN, "EB 01  ? 9C EB 01  ? 53 EB 01  ? 83 24 24 00 EB 01  ? 87 0C 24 EB 01  ? F3 A4 EB 01"); 
      if(ea==BADADDR) {
         Message(form("Obfuscation (type15) %d\n", i-1));
         return;
      }
      if(ea != 0) {
         FillNOP(ea, len);
         MakeUnknown(ea, len, 0);
         MakeData(ea+1, FF_BYTE, 1, 0);
         MakeArray(ea+1, len-1);
         HideArea(ea+1, ea+len, 
                  form("Obfuscation (type15) #%03d [%08X - %08X]",i,ea,ea+len), 
                  "==>", "<==", -1);
         ea = ea + len-1;
         i = i + 1;
      }
      else
         ea = ea + 1;
   }
}

static find_poly16(ea)
{
   auto i, len;
   len = 52;
   i = 1;
   for(;;) {
      ea=FindBinary(ea, SEARCH_DOWN, "EB 01  ? E8 17 00 00 00 E9 EB 01  ? E8 17 00 00 00 E8 EB 01  ? 8D 64 24 10 EB 01  ?");
      if(ea==BADADDR) {
         Message(form("Obfuscation (type16) %d\n", i-1));
         return;
      }
      if(ea != 0) {
         FillNOP(ea, len);
         MakeUnknown(ea, len, 0);
         MakeData(ea+1, FF_BYTE, 1, 0);
         MakeArray(ea+1, len-1);
         HideArea(ea+1, ea+len, 
                  form("Obfuscation (type16) #%03d [%08X - %08X]",i,ea,ea+len), 
                  "==>", "<==", -1);
         ea = ea + len-1;
         i = i + 1;
      }
      else
         ea = ea + 1;
   }
}

static find_poly17(ea)
{
   auto i, len;
   len = 65;
   i = 1;
   for(;;) {
      ea=FindBinary(ea, SEARCH_DOWN, "EB 01  ? 60 EB 01  ? 9C EB 01  ? F7 D2 EB 01  ? 05  ?  ?  ?  ? EB 01  ? D3 C6 EB 01");
      if(ea==BADADDR) {
         Message(form("Obfuscation (type17) %d\n", i-1));
         return;
      }
      if(ea != 0) {
         FillNOP(ea, len);
         MakeUnknown(ea, len, 0);
         MakeData(ea+1, FF_BYTE, 1, 0);
         MakeArray(ea+1, len-1);
         HideArea(ea+1, ea+len, 
                  form("Obfuscation (type17) #%03d [%08X - %08X]",i,ea,ea+len), 
                  "==>", "<==", -1);
         ea = ea + len-1;
         i = i + 1;
      }
      else
         ea = ea + 1;
   }
}

static find_poly18(ea)
{
   auto i, len;
   len = 65;
   i = 1;
   for(;;) {
      ea=FindBinary(ea, SEARCH_DOWN, "EB 01  ? 51 EB 01  ? 9C EB 01  ? 51 EB 01  ? 81 FA  ?  ?  ?  ? EB 01  ? F7 1C 24 EB");
      if(ea==BADADDR) {
         Message(form("Obfuscation (type18) %d\n", i-1));
         return;
      }
      if(ea != 0) {
         FillNOP(ea, len);
         MakeUnknown(ea, len, 0);
         MakeData(ea+1, FF_BYTE, 1, 0);
         MakeArray(ea+1, len-1);
         HideArea(ea+1, ea+len, 
                  form("Obfuscation (type18) #%03d [%08X - %08X]",i,ea,ea+len), 
                  "==>", "<==", -1);
         ea = ea + len-1;
         i = i + 1;
      }
      else
         ea = ea + 1;
   }
}

static find_poly19(ea)
{
   auto i, len;
   len = 59;
   i = 1;
   for(;;) {
      ea=FindBinary(ea, SEARCH_DOWN, "EB 01  ? 9C EB 01  ? 55 EB 01  ? 33 2C 24 EB 01  ? 87 DE EB 01  ? 01 FD EB 01  ? F7");
      if(ea==BADADDR) {
         Message(form("Obfuscation (type19) %d\n", i-1));
         return;
      }
      if(ea != 0) {
         FillNOP(ea, len);
         MakeUnknown(ea, len, 0);
         MakeData(ea+1, FF_BYTE, 1, 0);
         MakeArray(ea+1, len-1);
         HideArea(ea+1, ea+len, 
                  form("Obfuscation (type19) #%03d [%08X - %08X]",i,ea,ea+len), 
                  "==>", "<==", -1);
         ea = ea + len-1;
         i = i + 1;
      }
      else
         ea = ea + 1;
   }
}

static find_poly20(ea)
{
   auto i, len;
   len = 55;
   i = 1;
   for(;;) {
      ea=FindBinary(ea, SEARCH_DOWN, "EB 01  ? 60 EB 01  ? 9C EB 01  ? 16 EB 01  ? 17 9C EB 01  ? 29 C0 EB 01  ? 2D 00 FF");
      if(ea==BADADDR) {
         Message(form("Obfuscation (type20) %d\n", i-1));
         return;
      }
      if(ea != 0) {
         FillNOP(ea, len);
         MakeUnknown(ea, len, 0);
         MakeData(ea+1, FF_BYTE, 1, 0);
         MakeArray(ea+1, len-1);
         HideArea(ea+1, ea+len, 
                  form("Obfuscation (type20) #%03d [%08X - %08X]",i,ea,ea+len), 
                  "==>", "<==", -1);
         ea = ea + len-1;
         i = i + 1;
      }
      else
         ea = ea + 1;
   }
}

static find_poly21(ea)
{
   auto i, len;
   len = 72;
   i = 1;
   for(;;) {
      ea=FindBinary(ea, SEARCH_DOWN, "EB 01  ? 51 EB 01  ? 9C EB 01  ? 31 C9 EB 01  ? 01 D6 EB 01  ? 29 C7 EB 01  ? F7 C7");
      if(ea==BADADDR) {
         Message(form("Obfuscation (type21) %d\n", i-1));
         return;
      }
      if(ea != 0) {
         FillNOP(ea, len);
         MakeUnknown(ea, len, 0);
         MakeData(ea+1, FF_BYTE, 1, 0);
         MakeArray(ea+1, len-1);
         HideArea(ea+1, ea+len, 
                  form("Obfuscation (type21) #%03d [%08X - %08X]",i,ea,ea+len), 
                  "==>", "<==", -1);
         ea = ea + len-1;
         i = i + 1;
      }
      else
         ea = ea + 1;
   }
}

static find_poly22(ea)
{
   auto i, len;
   len = 46;
   i = 1;
   for(;;) {
      ea=FindBinary(ea, SEARCH_DOWN, "EB 01  ? 9C EB 01  ? 87 04 24 EB 01  ? E8 01 00 00 00 E9 89 04 24 EB 01  ? 3D  ?  ?");
      if(ea==BADADDR) {
         Message(form("Obfuscation (type22) %d\n", i-1));
         return;
      }
      if(ea != 0) {
         FillNOP(ea, len);
         MakeUnknown(ea, len, 0);
         MakeData(ea+1, FF_BYTE, 1, 0);
         MakeArray(ea+1, len-1);
         HideArea(ea+1, ea+len, 
                  form("Obfuscation (type22) #%03d [%08X - %08X]",i,ea,ea+len), 
                  "==>", "<==", -1);
         ea = ea + len-1;
         i = i + 1;
      }
      else
         ea = ea + 1;
   }
}

static find_poly23(ea)
{
   auto i, len;
   len = 43;
   i = 1;
   for(;;) {
      ea=FindBinary(ea, SEARCH_DOWN, "EB 01  ? 8D 00 EB 01  ? 89 C9 EB 01  ? 87 D2 EB 01  ? 8D 1B EB 01  ? 89 E4 EB 01  ?");
      if(ea==BADADDR) {
         Message(form("Obfuscation (type23) %d\n", i-1));
         return;
      }
      if(ea != 0) {
         FillNOP(ea, len);
         MakeUnknown(ea, len, 0);
         MakeData(ea+1, FF_BYTE, 1, 0);
         MakeArray(ea+1, len-1);
         HideArea(ea+1, ea+len, 
                  form("Obfuscation (type23) #%03d [%08X - %08X]",i,ea,ea+len), 
                  "==>", "<==", -1);
         ea = ea + len-1;
         i = i + 1;
      }
      else
         ea = ea + 1;
   }
}

static find_poly24(ea)
{
   auto i, len;
   len = 57;
   i = 1;
   for(;;) {
      ea=FindBinary(ea, SEARCH_DOWN, "EB 01  ? 9C EB 01  ? 87 04 24 EB 01  ? E8 0E 00 00 00 E9 74 17 EB 01  ? 75 12 E8 EB");
      if(ea==BADADDR) {
         Message(form("Obfuscation (type24) %d\n", i-1));
         return;
      }
      if(ea != 0) {
         FillNOP(ea, len);
         MakeUnknown(ea, len, 0);
         MakeData(ea+1, FF_BYTE, 1, 0);
         MakeArray(ea+1, len-1);
         HideArea(ea+1, ea+len, 
                  form("Obfuscation (type24) #%03d [%08X - %08X]",i,ea,ea+len), 
                  "==>", "<==", -1);
         ea = ea + len-1;
         i = i + 1;
      }
      else
         ea = ea + 1;
   }
}

static find_poly25(ea)
{
   auto i, len;
   len = 44;
   i = 1;
   for(;;) {
      ea=FindBinary(ea, SEARCH_DOWN, "EB 01  ? 89 C0 EB 01  ? 87 C9 EB 01  ? 8D 12 EB 01  ? 89 DB EB 01  ? 87 E4 EB 01  ?");
      if(ea==BADADDR) {
         Message(form("Obfuscation (type25) %d\n", i-1));
         return;
      }
      if(ea != 0) {
         FillNOP(ea, len);
         MakeUnknown(ea, len, 0);
         MakeData(ea+1, FF_BYTE, 1, 0);
         MakeArray(ea+1, len-1);
         HideArea(ea+1, ea+len, 
                  form("Obfuscation (type25) #%03d [%08X - %08X]",i,ea,ea+len), 
                  "==>", "<==", -1);
         ea = ea + len-1;
         i = i + 1;
      }
      else
         ea = ea + 1;
   }
}

static find_poly26(ea)
{
   auto i, len;
   len = 60;
   i = 1;
   for(;;) {
      ea=FindBinary(ea, SEARCH_DOWN, "EB 01  ? 9C EB 01  ? 01 D8 EB 01  ? 29 D1 EB 01  ? 01 FE EB 01  ? 29 E5 EB 01  ? 81");
      if(ea==BADADDR) {
         Message(form("Obfuscation (type26) %d\n", i-1));
         return;
      }
      if(ea != 0) {
         FillNOP(ea, len);
         MakeUnknown(ea, len, 0);
         MakeData(ea+1, FF_BYTE, 1, 0);
         MakeArray(ea+1, len-1);
         HideArea(ea+1, ea+len, 
                  form("Obfuscation (type26) #%03d [%08X - %08X]",i,ea,ea+len), 
                  "==>", "<==", -1);
         ea = ea + len-1;
         i = i + 1;
      }
      else
         ea = ea + 1;
   }
}

static find_poly27(ea)
{
   auto i, len;
   len = 41;
   i = 1;
   for(;;) {
      ea=FindBinary(ea, SEARCH_DOWN, "EB 01  ? 9C EB 01  ? F2 9C EB 01  ? 81 24 24 00 01 00 00 EB 01  ? 74 06 EB 01  ? FF");
      if(ea==BADADDR) {
         Message(form("Obfuscation (type27) %d\n", i-1));
         return;
      }
      if(ea != 0) {
         FillNOP(ea, len);
         MakeUnknown(ea, len, 0);
         MakeData(ea+1, FF_BYTE, 1, 0);
         MakeArray(ea+1, len-1);
         HideArea(ea+1, ea+len, 
                  form("Obfuscation (type27) #%03d [%08X - %08X]",i,ea,ea+len), 
                  "==>", "<==", -1);
         ea = ea + len-1;
         i = i + 1;
      }
      else
         ea = ea + 1;
   }
}

static find_poly28(ea)
{
   auto i, len;
   len = 76;
   i = 1;
   for(;;) {
      ea=FindBinary(ea, SEARCH_DOWN, "EB 01  ? 68  ?  ?  ?  ? EB 01  ? 68  ?  ?  ?  ? EB 01  ? 68  ?  ?  ?  ? EB 01  ? E8");
      if(ea==BADADDR) {
         Message(form("Obfuscation (type28) %d\n", i-1));
         return;
      }
      if(ea != 0) {
         FillNOP(ea, len);
         MakeUnknown(ea, len, 0);
         MakeData(ea+1, FF_BYTE, 1, 0);
         MakeArray(ea+1, len-1);
         HideArea(ea+1, ea+len, 
                  form("Obfuscation (type28) #%03d [%08X - %08X]",i,ea,ea+len), 
                  "==>", "<==", -1);
         ea = ea + len-1;
         i = i + 1;
      }
      else
         ea = ea + 1;
   }
}

static find_poly29(ea)
{
   auto i, len;
   len = 37;
   i = 1;
   for(;;) {
      ea=FindBinary(ea, SEARCH_DOWN, "EB 01  ? 51 EB 01  ? 57 EB 01  ? 56 EB 01  ? 59 EB 01  ? 5E EB 01  ? 5F EB 01  ? 87");
      if(ea==BADADDR) {
         Message(form("Obfuscation (type29) %d\n", i-1));
         return;
      }
      if(ea != 0) {
         FillNOP(ea, len);
         MakeUnknown(ea, len, 0);
         MakeData(ea+1, FF_BYTE, 1, 0);
         MakeArray(ea+1, len-1);
         HideArea(ea+1, ea+len, 
                  form("Obfuscation (type29) #%03d [%08X - %08X]",i,ea,ea+len), 
                  "==>", "<==", -1);
         ea = ea + len-1;
         i = i + 1;
      }
      else
         ea = ea + 1;
   }
}

static find_poly30(ea)
{
   auto i, len;
   len = 74;
   i = 1;
   for(;;) {
      ea=FindBinary(ea, SEARCH_DOWN, "EB 01  ? 52 EB 01  ? 87 DA EB 01  ? 68  ?  ?  ?  ? EB 01  ? 5B EB 01  ? E8 20 00 00");
      if(ea==BADADDR) {
         Message(form("Obfuscation (type30) %d\n", i-1));
         return;
      }
      if(ea != 0) {
         FillNOP(ea, len);
         MakeUnknown(ea, len, 0);
         MakeData(ea+1, FF_BYTE, 1, 0);
         MakeArray(ea+1, len-1);
         HideArea(ea+1, ea+len, 
                  form("Obfuscation (type30) #%03d [%08X - %08X]",i,ea,ea+len), 
                  "==>", "<==", -1);
         ea = ea + len-1;
         i = i + 1;
      }
      else
         ea = ea + 1;
   }
}

static find_poly31(ea)
{
   auto i, len;
   len = 57;
   i = 1;
   for(;;) {
      ea=FindBinary(ea, SEARCH_DOWN, "EB 01  ? 89 44 24 F8 EB 01  ? 9C EB 01  ? 81 FB  ?  ?  ?  ? EB 01  ? 29 C0 EB 01  ?");
      if(ea==BADADDR) {
         Message(form("Obfuscation (type31) %d\n", i-1));
         return;
      }
      if(ea != 0) {
         FillNOP(ea, len);
         MakeUnknown(ea, len, 0);
         MakeData(ea+1, FF_BYTE, 1, 0);
         MakeArray(ea+1, len-1);
         HideArea(ea+1, ea+len, 
                  form("Obfuscation (type31) #%03d [%08X - %08X]",i,ea,ea+len), 
                  "==>", "<==", -1);
         ea = ea + len-1;
         i = i + 1;
      }
      else
         ea = ea + 1;
   }
}

static find_poly32(ea)
{
   auto i, len;
   len = 74;
   i = 1;
   for(;;) {
      ea=FindBinary(ea, SEARCH_DOWN, "EB 01  ? 74 30 EB 01  ? 75 2B E8 EB 01  ? E8 2D 00 00 00 E9 EB 01  ? 7D F2 EB 01  ?");
      if(ea==BADADDR) {
         Message(form("Obfuscation (type32) %d\n", i-1));
         return;
      }
      if(ea != 0) {
         FillNOP(ea, len);
         MakeUnknown(ea, len, 0);
         MakeData(ea+1, FF_BYTE, 1, 0);
         MakeArray(ea+1, len-1);
         HideArea(ea+1, ea+len, 
                  form("Obfuscation (type32) #%03d [%08X - %08X]",i,ea,ea+len), 
                  "==>", "<==", -1);
         ea = ea + len-1;
         i = i + 1;
      }
      else
         ea = ea + 1;
   }
}

static find_poly33(ea)
{
   auto i, len;
   len = 64;
   i = 1;
   for(;;) {
      ea=FindBinary(ea, SEARCH_DOWN, "EB 01  ? 68  ?  ?  ?  ? EB 01  ? 87 2C 24 EB 01  ? 9C EB 01  ? 01 E8 EB 01  ? 29 C7");
      if(ea==BADADDR) {
         Message(form("Obfuscation (type33) %d\n", i-1));
         return;
      }
      if(ea != 0) {
         FillNOP(ea, len);
         MakeUnknown(ea, len, 0);
         MakeData(ea+1, FF_BYTE, 1, 0);
         MakeArray(ea+1, len-1);
         HideArea(ea+1, ea+len, 
                  form("Obfuscation (type33) #%03d [%08X - %08X]",i,ea,ea+len), 
                  "==>", "<==", -1);
         ea = ea + len-1;
         i = i + 1;
      }
      else
         ea = ea + 1;
   }
}

static find_poly34(ea)
{
   auto i, len;
   len = 37;
   i = 1;
   for(;;) {
      ea=FindBinary(ea, SEARCH_DOWN, "EB 01  ? F7 D4 EB 01  ? 96 EB 01  ? 87 DA EB 01  ? 8D 6D 00 EB 01  ? F7 D4 EB 01  ?");
      if(ea==BADADDR) {
         Message(form("Obfuscation (type34) %d\n", i-1));
         return;
      }
      if(ea != 0) {
         FillNOP(ea, len);
         MakeUnknown(ea, len, 0);
         MakeData(ea+1, FF_BYTE, 1, 0);
         MakeArray(ea+1, len-1);
         HideArea(ea+1, ea+len, 
                  form("Obfuscation (type34) #%03d [%08X - %08X]",i,ea,ea+len), 
                  "==>", "<==", -1);
         ea = ea + len-1;
         i = i + 1;
      }
      else
         ea = ea + 1;
   }
}

static find_poly35(ea)
{
   auto i, len;
   len = 43;
   i = 1;
   for(;;) {
      ea=FindBinary(ea, SEARCH_DOWN, "EB 01  ? 90 EB 01  ? 8D 09 EB 01  ? 89 D2 EB 01  ? 87 DB EB 01  ? 8D 24 24 EB 01  ?");
      if(ea==BADADDR) {
         Message(form("Obfuscation (type35) %d\n", i-1));
         return;
      }
      if(ea != 0) {
         FillNOP(ea, len);
         MakeUnknown(ea, len, 0);
         MakeData(ea+1, FF_BYTE, 1, 0);
         MakeArray(ea+1, len-1);
         HideArea(ea+1, ea+len, 
                  form("Obfuscation (type35) #%03d [%08X - %08X]",i,ea,ea+len), 
                  "==>", "<==", -1);
         ea = ea + len-1;
         i = i + 1;
      }
      else
         ea = ea + 1;
   }
}

static find_poly36(ea)
{
   auto i, len;
   len = 44;
   i = 1;
   for(;;) {
      ea=FindBinary(ea, SEARCH_DOWN, "EB 01  ? 9C EB 01  ? 50 EB 01  ? F3 9C EB 01  ? 58 EB 01  ? 25 00 01 00 00 EB 01  ?");
      if(ea==BADADDR) {
         Message(form("Obfuscation (type36) %d\n", i-1));
         return;
      }
      if(ea != 0) {
         FillNOP(ea, len);
         MakeUnknown(ea, len, 0);
         MakeData(ea+1, FF_BYTE, 1, 0);
         MakeArray(ea+1, len-1);
         HideArea(ea+1, ea+len, 
                  form("Obfuscation (type36) #%03d [%08X - %08X]",i,ea,ea+len), 
                  "==>", "<==", -1);
         ea = ea + len-1;
         i = i + 1;
      }
      else
         ea = ea + 1;
   }
}

static find_poly37(ea)
{
   auto i, len;
   len = 69;
   i = 1;
   for(;;) {
      ea=FindBinary(ea, SEARCH_DOWN, "EB 01  ? E8 16 00 00 00 E9 EB 37 E8 EB 01  ? C3 E9 EB 01  ? E8 F3 FF FF FF EB 01  ?");
      if(ea==BADADDR) {
         Message(form("Obfuscation (type37) %d\n", i-1));
         return;
      }
      if(ea != 0) {
         FillNOP(ea, len);
         MakeUnknown(ea, len, 0);
         MakeData(ea+1, FF_BYTE, 1, 0);
         MakeArray(ea+1, len-1);
         HideArea(ea+1, ea+len, 
                  form("Obfuscation (type37) #%03d [%08X - %08X]",i,ea,ea+len), 
                  "==>", "<==", -1);
         ea = ea + len-1;
         i = i + 1;
      }
      else
         ea = ea + 1;
   }
}

static find_poly38(ea)
{
   auto i, len;
   len = 46;
   i = 1;
   for(;;) {
      ea=FindBinary(ea, SEARCH_DOWN, "EB 01  ? 68  ?  ?  ?  ? EB 01  ? 89 04 24 EB 01  ? 8D 84 03  ?  ?  ?  ? EB 01  ? 8D");
      if(ea==BADADDR) {
         Message(form("Obfuscation (type38) %d\n", i-1));
         return;
      }
      if(ea != 0) {
         FillNOP(ea, len);
         MakeUnknown(ea, len, 0);
         MakeData(ea+1, FF_BYTE, 1, 0);
         MakeArray(ea+1, len-1);
         HideArea(ea+1, ea+len, 
                  form("Obfuscation (type38) #%03d [%08X - %08X]",i,ea,ea+len), 
                  "==>", "<==", -1);
         ea = ea + len-1;
         i = i + 1;
      }
      else
         ea = ea + 1;
   }
}

static find_poly39(ea)
{
   auto i, len;
   len = 67;
   i = 1;
   for(;;) {
      ea=FindBinary(ea, SEARCH_DOWN, "EB 01  ? 9C EB 01  ? 96 EB 01  ? F7 C3  ?  ?  ?  ? EB 01  ? 74 03 EB 01  ? 87 CF EB");
      if(ea==BADADDR) {
         Message(form("Obfuscation (type39) %d\n", i-1));
         return;
      }
      if(ea != 0) {
         FillNOP(ea, len);
         MakeUnknown(ea, len, 0);
         MakeData(ea+1, FF_BYTE, 1, 0);
         MakeArray(ea+1, len-1);
         HideArea(ea+1, ea+len, 
                  form("Obfuscation (type39) #%03d [%08X - %08X]",i,ea,ea+len), 
                  "==>", "<==", -1);
         ea = ea + len-1;
         i = i + 1;
      }
      else
         ea = ea + 1;
   }
}

static find_poly40(ea)
{
   auto i, len;
   len = 43;
   i = 1;
   for(;;) {
      ea=FindBinary(ea, SEARCH_DOWN, "EB 01  ? 89 C0 EB 01  ? 89 C9 EB 01  ? 89 D2 EB 01  ? 89 DB EB 01  ? 89 E4 EB 01  ?");
      if(ea==BADADDR) {
         Message(form("Obfuscation (type40) %d\n", i-1));
         return;
      }
      if(ea != 0) {
         FillNOP(ea, len);
         MakeUnknown(ea, len, 0);
         MakeData(ea+1, FF_BYTE, 1, 0);
         MakeArray(ea+1, len-1);
         HideArea(ea+1, ea+len, 
                  form("Obfuscation (type40) #%03d [%08X - %08X]",i,ea,ea+len), 
                  "==>", "<==", -1);
         ea = ea + len-1;
         i = i + 1;
      }
      else
         ea = ea + 1;
   }
}

static find_poly41(ea)
{
   auto i, len;
   len = 64;
   i = 1;
   for(;;) {
      ea=FindBinary(ea, SEARCH_DOWN, "EB 01  ? 55 EB 01  ? 89 E5 EB 01  ? 51 EB 01  ? B9 0F 00 00 00 EB 01  ? 9C EB 01  ?");
      if(ea==BADADDR) {
         Message(form("Obfuscation (type41) %d\n", i-1));
         return;
      }
      if(ea != 0) {
         FillNOP(ea, len);
         MakeUnknown(ea, len, 0);
         MakeData(ea+1, FF_BYTE, 1, 0);
         MakeArray(ea+1, len-1);
         HideArea(ea+1, ea+len, 
                  form("Obfuscation (type41) #%03d [%08X - %08X]",i,ea,ea+len), 
                  "==>", "<==", -1);
         ea = ea + len-1;
         i = i + 1;
      }
      else
         ea = ea + 1;
   }
}

static find_poly42(ea)
{
   auto i, len;
   len = 54;
   i = 1;
   for(;;) {
      ea=FindBinary(ea, SEARCH_DOWN, "EB 01  ? 9C EB 01  ? 51 EB 01  ? 81 F9  ?  ?  ?  ? EB 01  ? B9 0F 00 00 00 EB 01  ?");
      if(ea==BADADDR) {
         Message(form("Obfuscation (type42) %d\n", i-1));
         return;
      }
      if(ea != 0) {
         FillNOP(ea, len);
         MakeUnknown(ea, len, 0);
         MakeData(ea+1, FF_BYTE, 1, 0);
         MakeArray(ea+1, len-1);
         HideArea(ea+1, ea+len, 
                  form("Obfuscation (type42) #%03d [%08X - %08X]",i,ea,ea+len), 
                  "==>", "<==", -1);
         ea = ea + len-1;
         i = i + 1;
      }
      else
         ea = ea + 1;
   }
}


static main()
{
   auto ea;
   ea=ScreenEA();
   find_poly1(ea);
   find_poly2(ea);
   find_poly3(ea);
   find_poly4(ea);
   find_poly5(ea);
   find_poly6(ea);
   find_poly7(ea);
   find_poly8(ea);
   find_poly9(ea);
   find_poly10(ea);
   find_poly11(ea);
   find_poly12(ea);
   find_poly13(ea);
   find_poly14(ea);
   find_poly15(ea);
   find_poly16(ea);
   find_poly17(ea);
   find_poly18(ea);
   find_poly19(ea);
   find_poly20(ea);
   find_poly21(ea);
   find_poly22(ea);
   find_poly23(ea);
   find_poly24(ea);
   find_poly25(ea);
   find_poly26(ea);
   find_poly27(ea);
   find_poly28(ea);
   find_poly29(ea);
   find_poly30(ea);
   find_poly31(ea);
   find_poly32(ea);
   find_poly33(ea);
   find_poly34(ea);
   find_poly35(ea);
   find_poly36(ea);
   find_poly37(ea);
   find_poly38(ea);
   find_poly39(ea);
   find_poly40(ea);
   find_poly41(ea);
   find_poly42(ea);
}


// EB 01  ? 9C EB 01  ? 51 EB 01  ? 81 FF  ?  ?  ?  ? EB 01  ? 83 E1 00 EB 01  ? F3 AE
// EB 01  ? 8D 00 EB 01  ? 8D 09 EB 01  ? 8D 12 EB 01  ? 8D 1B EB 01  ? 8D 24 24 EB 01
// EB 01  ? 9c EB 01  ? E8 01 00 00 00  ? EB 01  ? 81 04 24  ?  ?  ?  ? EB 01  ? 97 EB
// EB 01  ? 55 EB 01  ? E8 04 00 00 00  ? EB 19  ? EB 01  ? 5D EB 01  ? 8D 6D 01 EB 01 
// EB 01  ? 74 06 EB 01  ? 75 0A E9 EB 01  ? E8 0A 00 00 00  ? EB 01  ? E8 01 00 00 00
// EB 01  ? E8 10 00 00 00 EB 01 E8 17 00 00 00 EB 01 E8 09 00 00 00 EB 01 E8 F4 FF FF 
// EB 01  ? 8D 64 24 FC EB 01  ? 87 04 24 EB 01  ? 68  ?  ?  ?  ? EB 01  ? 58 EB 01  ?
// EB 01  ? 87 F7 EB 01  ? 9C EB 01  ? 6A 00 EB 01  ? 01 14 24 EB 01  ? 81 F2  ?  ?  ?
// EB 01  ? 68  ?  ?  ?  ? EB 01  ? 68  ?  ?  ?  ? EB 01  ? 87 04 24 EB 01  ? 87 5C 24
// EB 01  ? E8 19 00 00 00 EB 01  ? E8 01 00 00 00 E9 EB 01  ? 87 04 24 EB 01  ? 58 EB 
// EB 01  ? 9C EB 01  ? 50 EB 01  ? 05  ?  ?  ?  ? EB 01  ? F7 D8 EB 01  ? 2D  ?  ?  ?
// EB 01  ? 68  ?  ?  ?  ? EB 01  ? E8 12 00 00 00 EB 01  ? 8D 64 24 04 EB 01  ? 73 0B 
// EB 01  ? 7E 09 EB 01  ? 7D 04 EB 01  ? CC EB 01  ? 8D 6D 00 EB 01
// EB 01  ? 90 EB 01  ? 87 C9 EB 01  ? 87 D2 EB 01  ? 87 DB EB 01  ? 87 E4 EB 01  ? 87
// EB 01  ? 9C EB 01  ? 53 EB 01  ? 83 24 24 00 EB 01  ? 87 0C 24 EB 01  ? F3 A4 EB 01
// EB 01  ? E8 17 00 00 00 E9 EB 01  ? E8 17 00 00 00 E8 EB 01  ? 8D 64 24 10 EB 01  ?
// EB 01  ? 60 EB 01  ? 9C EB 01  ? F7 D2 EB 01  ? 05  ?  ?  ?  ? EB 01  ? D3 C6 EB 01 
// EB 01  ? 51 EB 01  ? 9C EB 01  ? 51 EB 01  ? 81 FA  ?  ?  ?  ? EB 01  ? F7 1C 24 EB
// EB 01  ? 9C EB 01  ? 55 EB 01  ? 33 2C 24 EB 01  ? 87 DE EB 01  ? 01 FD EB 01  ? F7
// EB 01  ? 60 EB 01  ? 9C EB 01  ? 16 EB 01  ? 17 9C EB 01  ? 29 C0 EB 01  ? 2D 00 FF
// EB 01  ? 51 EB 01  ? 9C EB 01  ? 31 C9 EB 01  ? 01 D6 EB 01  ? 29 C7 EB 01  ? F7 C7
// EB 01  ? 9C EB 01  ? 87 04 24 EB 01  ? E8 01 00 00 00 E9 89 04 24 EB 01  ? 3D  ?  ?
// EB 01  ? 8D 00 EB 01  ? 89 C9 EB 01  ? 87 D2 EB 01  ? 8D 1B EB 01  ? 89 E4 EB 01  ?
// EB 01  ? 9C EB 01  ? 87 04 24 EB 01  ? E8 0E 00 00 00 E9 74 17 EB 01  ? 75 12 E8 EB
// EB 01  ? 89 C0 EB 01  ? 87 C9 EB 01  ? 8D 12 EB 01  ? 89 DB EB 01  ? 87 E4 EB 01  ?
// EB 01  ? 9C EB 01  ? 01 D8 EB 01  ? 29 D1 EB 01  ? 01 FE EB 01  ? 29 E5 EB 01  ? 81
// EB 01  ? 9C EB 01  ? F2 9C EB 01  ? 81 24 24 00 01 00 00 EB 01  ? 74 06 EB 01  ? FF
// EB 01  ? 68  ?  ?  ?  ? EB 01  ? 68  ?  ?  ?  ? EB 01  ? 68  ?  ?  ?  ? EB 01  ? E8 
// EB 01  ? 51 EB 01  ? 57 EB 01  ? 56 EB 01  ? 59 EB 01  ? 5E EB 01  ? 5F EB 01  ? 87 
// EB 01  ? 52 EB 01  ? 87 DA EB 01  ? 68  ?  ?  ?  ? EB 01  ? 5B EB 01  ? E8 20 00 00
// EB 01  ? 89 44 24 F8 EB 01  ? 9C EB 01  ? 81 FB  ?  ?  ?  ? EB 01  ? 29 C0 EB 01  ? 
// EB 01  ? 74 30 EB 01  ? 75 2B E8 EB 01  ? E8 2D 00 00 00 E9 EB 01  ? 7D F2 EB 01  ?
// EB 01  ? 68  ?  ?  ?  ? EB 01  ? 87 2C 24 EB 01  ? 9C EB 01  ? 01 E8 EB 01  ? 29 C7
// EB 01  ? F7 D4 EB 01  ? 96 EB 01  ? 87 DA EB 01  ? 8D 6D 00 EB 01  ? F7 D4 EB 01  ?
// EB 01  ? 90 EB 01  ? 8D 09 EB 01  ? 89 D2 EB 01  ? 87 DB EB 01  ? 8D 24 24 EB 01  ?
// EB 01  ? 9C EB 01  ? 50 EB 01  ? F3 9C EB 01  ? 58 EB 01  ? 25 00 01 00 00 EB 01  ?
// EB 01  ? E8 16 00 00 00 E9 EB 37 E8 EB 01  ? C3 E9 EB 01  ? E8 F3 FF FF FF EB 01  ?
// EB 01  ? 68  ?  ?  ?  ? EB 01  ? 89 04 24 EB 01  ? 8D 84 03  ?  ?  ?  ? EB 01  ? 8D
// EB 01  ? 9C EB 01  ? 96 EB 01  ? F7 C3  ?  ?  ?  ? EB 01  ? 74 03 EB 01  ? 87 CF EB
// EB 01  ? 89 C0 EB 01  ? 89 C9 EB 01  ? 89 D2 EB 01  ? 89 DB EB 01  ? 89 E4 EB 01  ?
// EB 01  ? 55 EB 01  ? 89 E5 EB 01  ? 51 EB 01  ? B9 0F 00 00 00 EB 01  ? 9C EB 01  ?
// EB 01  ? 9C EB 01  ? 51 EB 01  ? 81 F9  ?  ?  ?  ? EB 01  ? B9 0F 00 00 00 EB 01  ?
// EB 01  ? 
// EB 01  ? 
